WEBSITE: https://r-ega.net

Changes in version 2.0.6

o FIX: bug when using `na.data = "listwise"` in standard `cor()` function

o FIX: update to revised network loadings signs

o FIX: bug in argument 'returnAllResults' for `EBICglasso.qgraph`

o FIX: bug when passing additional non-`dimensionStability` arugments into `bootEGA`

o FIX: bug when printing `hierEGA` summary from `bootEGA`

o UPDATE: colors in `itemStability` plots will match colors of `hierEGA` plot

o UPDATE: `network.predictability` uses empirical inverse variances (rather than network-implied)

o UPDATE: R-squared in `continuous_accuracy` helper uses formula for no intercept


Changes in version 2.0.5

o FIX: 'stroke' parameter in `hierEGA` that broke with {ggplot2} update

o ADD: `network.predictability` to predict new data based on a network

o ADD: `network.generalizability` to estimate network generalizability to new data (leverages `network.predictability`)

o UPDATE: new loadings (`net.loads(..., loading.method = "experimental")`) have been added to resolve issues in original loadings (e.g., signs, cross-loadings, standardization) 

o UPDATE: `plot.bootEGA` will output `itemStability` plot by default

o UPDATE: `dimensionStability` output now included in `bootEGA` as output `$stability`

o UPDATE: 'rotate' argument added to `infoCluster` plot to allow for different angle of dendrogram

o DEPENDENCY: {fungible} is now 'IMPORTS' over 'SUGGESTS' for dependency in new loadings

o DEPRECATED: `typicalStructure` and `plot.typicalStructure` have been deprecated to `FALSE`


Changes in version 2.0.4

o FIX: plotting for `infoCluster` when there are grey lines involved (or not)

o FIX: pass of multiple passes of `resolution_parameter` causing an error in {igraph} 2.0.0 for `EGA.fit` (see issue #148)

o ADD: `community.compare` to perform permutation test to determine statistical significance of cluster similarity

o UPDATE: moved `reindex_memberships` to helpers

o UPDATE: `reindex_memberships` used in `community.homogenize`


Changes in version 2.0.3

o FIX: freed `edge.*` arguments in `compare.EGA.plots` to allow full customization

o UPDATE: optimizations for speed and memory in `ergoInfo` and `boot.ergoInfo`

o DEPENDENCY: swapped out {ggdendro} for {dendextend}


Changes in version 2.0.2

o FIX: ties for max gain in `TMFG`

o FIX: continuous variables with few categories that are treated as ordinal in `polychoric.matrix`

o FIX: character input for `structure` is now accepted

o ADD: website pointing to different data check errors added to error output (hopefully, makes errors more understandable)

o UPDATE: `corr = "cor_auto"` now performs `qgraph::cor_auto` in favor of legacy; previous behavior starting at 2.0.0 was to deprecate `"cor_auto"` in favor of `"auto"`; default remains `corr = "auto"`

o UPDATE: `compare.EGA.plots` outputs `$all` and `$individual` for the plots

o UPDATE: when `structure` is supplied for `invariance`, then configural check is skipped (structure is assumed to be invariant)

o UPDATE: added data generation for `model = "BGGM"` and `uni.method = "expand"` in `community.unidimensional`

o DEPENDENCY: {BGGM} has been removed until dependency chain on CRAN can be resolved


Changes in version 2.0.1

o updated the polychoric C code to avoid out-of-bounds access errors


Changes in version 2.0.0

o MAJOR REFACTOR: the update to version 2.0.0 includes many major changes that are designed to improve the speed, reliability, and reproducibility of {EGAnet}. The goal of these changes are to eliminate common errors and streamline the code in the package to prevent future error cases. There are several function additions that are provided to facilitate modular use of the {EGAnet} package

o INTERNALS: function-specific internal functions and S3methods are now located in their respective .R files rather than elsewhere (e.g., "utils-EGAnet.R")

o SWAP: internal script usage of "utils-EGAnet.R" depracated for "helper.R" functions that are used across the package (no visible changes for the user)

o NOTE: default objective function for Leiden algorithm is set to "modularity"

o NOTE: default for Louvain unidimensional method is set to single-shot *unless* argument "consensus.method" or "consensus.iter" is specified

o ADD: stricter `*apply` functions that are roughly equivalent to `*apply` but have stricter inputs/outputs (uses `vapply` as foundation; often, slightly faster)

o ADD: `community.consensus` to apply the Consensus Clustering approach introduced by Lancichnetti & Fortunato (2012). Currently only available for the Louvain algorithm

o ADD: `community.detection` to apply community detection algorithms as a standalone function

o ADD: convenience function to convert an {igraph} object to a standard matrix (`igraph2matrix`)

o ADD: `modularity` to compute standard (absolute values) and signed modularity (implemented in C)

o ADD: `polychoric.matrix` to compute categorical correlations (implemented in C); handles missing data ("pairwise" or "listwise") as well as empty cells in the joint frequency table (see documentation: `?polychoric.matrix`)

o ADD: `auto.correlate` now computes all correlations internally and no longer depends on external functions; categorical correlations are C based and bi/polyserial correlations are a simplified and vectorized version of {polycor}'s `polyserial`; substantial computational gains (between 10-25x faster than previous use of {qgraph}'s `cor_auto`)

o ADD: `network.estimation` to handle all network estimation in {EGAnet}; *includes* Bayesian GGM from {BGGM} for more seamless incorporation of BEGA

o ADD: `community.unidimensional` to apply different unidimensional community detection approaches; makes unidimensional community detection more modular and flexible

o ADD: basic (internal) function to handle all network plots to keep changes centralized to a single function; extends flexbility to handle all {GGally}'s `ggnet2` arguments

o ADD: implemented reproducible parametric bootstrapping and random sampling (see <https://github.com/hfgolino/EGAnet/wiki/Reproducibility-and-PRNG> for more details)

o ADD: implemented reproducible resampling bootstrapping and random sampling (see <https://github.com/hfgolino/EGAnet/wiki/Reproducibility-and-PRNG> for more details)

o ADD: reproducible bootstrapping with seed setting that does *not* affect R's seed and RNG (user's seed will not be affected and will not affected bootstrapping seeds)

o ADD: `community.homogenize` as a core function rather than internal (previously `homogenize.membership`); about 2.5x faster than the original version

o ADD: `convert2tidygraph` for `ggraph` and `tidygraph` support -- thanks to Dominique Makowski!

o ADD: "multilevel" plotting support for `hierEGA` (only used when `scores = "network"` since factor scores don't directly align with EGA detected dimensions)

o ADD: internal functions `shuffle` and `shuffle_replace` to replace `sample` with and without replacement; performed in C and allows seed setting independent of R (about 2-3x faster)

o ADD: xoshiro256++ PRNG for higher quailty random number generation, permutation, and resampling (~2x faster than `runif` and `sample`); based in C

o ADD: Ziggurat method for random normal generation over top xoshiro256++ (2-5x faster than `rnorm`); based in C

o ADD: configural invariance was added to `invariance` (see Details section)

o ADD: `genTEFI` to compute the Generalized Total Entropy Fit Index solely; `tefi` serves as a general function to compute TEFI for all `*EGA` classes

o REMOVE: `signed.louvain` until reproducibility can be sorted

o REMOVE: `methods.section` and `utils-EGAnet.methods.section` to avoid space issues in ./R directory (1MB)

o UPDATE: `EBICglasso.qgraph` and `TMFG` were optimized; `TMFG` is now 2x faster

o UPDATE: `TMFG` can now directly estimate a GGM with the argument 'partial = TRUE'; implements the Local-Global Inversion method from Barfuss et al. (2016)

o UPDATE: switched on "Byte-Compile" (byte-compiles on our end and not when the user installs)

o UPDATE: `EGA.estimate` and `EGA` core functions have been updated for seamless use with more basic functions `network.estimation` and `community.*` functions

o UPDATE: S3method updates for `EGA.estimate` and `EGA` to provide estimation information

o UPDATE: `EGA.fit` updated to be compatiable with all updates to `EGA.estimate` (other optimizations were implemented such as direct communtiy detection application and unique solution finding)

o UPDATE: `tefi` updated with several checks (slightly slower for correlation matrix but much faster with raw data; includes data/matrix checks)

o UPDATE: `entropyFit` uses more effective vectorization (about 5-7x faster)

o UPDATE: `Embed` and `glla` made to be more efficient and includes an internal `glla_setup` function to avoid the same matrix calculations for every participant in a sample for `dynEGA`

o UPDATE: `riEGA` updated to be compatiable with all lower-level updates (slightly faster)

o UPDATE: `wto` updated to be fully vectorized (about 12x faster)

o UPDATE: `totalCor` and `totalCorMat` updated to be fully vectorized (about 10x faster)

o UPDATE: implemented internal `fast.data.frame` for more efficient data frame initialization when all values in data frame are the same

o UPDATE: `bootEGA` allows flexibility to add any arguments from any `EGA*` functions; much faster due to optimizations across all functions ("resampling" is nearly as fast as "parametric")

o UPDATE: support for `EGA.fit` and `riEGA` added to `bootEGA` (support for `hierEGA` will be coming soon...)

o UPDATE: `itemStability` has been updated and runs about 2.5x faster due to `community.homogenize`; S3methods were added; greater flexibility available in plotting but not much support (e.g., error checking) yet

o UPDATE: `dimensionStability` has been updated and maintains speed gains from `itemStability`

o UPDATE: `dynEGA.ind.pop` now calls `dynEGA` with `level = c("individual", "population")`; legacy `dynEGA.ind.pop` class is maintained across ergodicity functions

o UPDATE: `ergoInfo` is about 2x faster

o UPDATE: `jsd` received several internal functions to expedite procedures in `infoCluster` and `jsd.ergoInfo`

o UPDATE: `net.loads` now includes 'loading.method' argument to allow for reproducibility with "BRM" implementation (and version 1.2.3); "experimental" implementation includes rotations alternative signs and cross-loading computation (potential future default)

o UPDATE: `net.scores` is much simpler (internally) and quicker; seamlessly integrates with `net.loads`

o UPDATE: `compare.EGA.plots` is faster, more flexible, and more reliable for comparing two or more plots

o UPDATE: `hierEGA` is faster and has new S3 methods

o UPDATE: S3 plotting for `invariance`

o UPDATE: `hierEGA` + `bootEGA` integration for `itemStability` and `dimensionStability` (includes full S3 methods)

o UPDATE: `UVA` supports legacy of inital conception in Christensen, Golino, and Silvia (EJP, 2020) but will no longer fix bugs related to: manual variable selection, "adapt" or "alpha" methods (warnings will be thrown)

o UPDATE: streamlined `UVA` (about 4x faster); fixed bugs related to reverse coding issues 

o UPDATE: `tefi` now handles all `EGA*` function objects including `hierEGA` which computes generalized TEFI

o UPDATE: documentation for all functions have been thoroughly revised to provide better instruction on how to use functions and their expected inputs

o DEPENDENCY: removed {network} because it is no longer used for plotting; switched {sna} to IMPORTS rather than SUGGESTS

o DEPENDENCY: removed {rstudioapi} from 'Suggests' because it was used in `colortext` and used in the package

o DEPENDENCY: removed {matrixcalc} because it was only used for trace of a matrix (own internal function is used)

o DEPENDENCY: {future} and {future.apply} are used for parallelization (better integration); includes internal function to check for available memory to not break in big data cases

o DEPENDENCY: {progress} and {progressr} are used for progress bars (in parallelization)

o DEPENDENCY: removed {psychTools} from 'Suggests' which was only used in examples

o DEPENDENCY: removed {rmarkdown} from 'Suggests' since it wasn't being used across the package


Changes in version 1.2.5.1

o FIX: cross-loading bug in `net.loads` was leading to problems when there were negative cross-loadings

o FIX: added `psych::factor.scores` scoring methods in `net.scores`

o ADD: `signed.louvain` to estimate the Signed Louvain algorithm (implemented in C)


Changes in version 1.2.5

o ADD: `most_common_tefi` method for `EGA` analyses


Changes in version 1.2.4

o REMOVE: `residualEGA` has been removed in favor of `riEGA` (removes {OpenMx} dependency)

o ADD: rotations to `net.loads` and `net.scores`

o UPDATE: `hierEGA` only outputs specified output (no longer outputs all possible consensus methods and scores combinations -- should be much faster)


Changes in version 1.2.3

o FIX: many bug fixes related to latest update; functions have largely returned to stable status

o UPDATE: Mac and Linux parallelizations have been optimized

o UPDATE: documented examples are more efficient for CRAN checks


Changes in version 1.2.1

o FIX: `bootEGA` read of bootstrap data (was not calling from `datalist` in `do.call` leading to perfect item stability)

o FIX: number of possible colors expanded to 70 (increased from 40)


Changes in version 1.2.0

o FIX: hex codes used in EGA plots

o FIX: `ordered = TRUE` for categorical data in *lavaan* CFAs

o UPDATE: consesnsus clustering is now used with Louvain in `EGA`

o UPDATE: print/summary S3methods have been standardized

o ADD/UPDATE: `boot.ergoInfo` has achieved functional working order. Results can be trusted to suggest whether dynamic data possess the ergodic property

o ADD: information theoretic clustering algorithm for dynamic data is available in `infoCluster`

o REMOVE: "alpha" and "adapt" options in `UVA` (removes {fitdistrplus} dependency)

o REMOVE: {qgraph} plots are no longer available

o ADD: `convert2igraph` is now a core function

o ADD: Jensen-Shannon Divergence `jsd` for determining (dis)similarity between network strcutures

o ADD: `riEGA`, `EGA.fit`, and `hierEGA` functionality to `bootEGA`

o ADD: `hierEGA` functionality to `itemStability` and `dimensionStability`

o UPDATE: "louvain" algorithm used as default for unidimensionality check in `EGA`

o INTERNAL: cleaned up `EGA` and `EGA.estimate`; streamlined code; no user facing differences


Changes in version 1.1.0

o FIX: CRAN note when `if(class(object))`. Replaced by `if(is(object))`.

o FIX: bug in `EGA.estimate` when using the TMFG network method. The resulting EGA plot did not have the correct node names.

o FIX: bug in `UVA` when trying to use sum score (`reduce.method = "sum"`) in automated procedure

o ADD: measurement `invariance` function for testing differences in network loadings between groups

o UPDATE: `itemStability` now has a parameter `structure` in which the user can specify a given structure to test its stability.

o ADD: `riEGA` implementing random-intercept EGA for wording effects

o ADD: `hierEGA` implementing hierarchical EGA

o FIX: consensus clustering for the Louvain algorithm

o ADD: `louvain` algorithm with added optimization option using `tefi`


Changes in version 1.0.0

o FIX: bug within the bootEGA function for `type = "resampling"`.

o UPDATE: default undimensionality adjustment has changed to leading eigenvalue (see Christensen, Garrido, & Golino, 2021 <https://doi.org/10.31234/osf.io/hz89e>). Previous unidimensionality adjustment in versions <= 0.9.8 can be applied using `uni.method = "expand"`

o UPDATE: default `UVA` was changed `type = "threshold"`

o UPDATE: `UVA` is now automated using `auto = TRUE`

o DEFUNCT: `dimStability` will no longer be supported. Instead, use `dimensionStability`

o REVAMP: `itemStability` has been recoded. Now includes error checking and more readable code

o FIX: bug for plotting NA communities

o FIX: bug for changing edge size in 'GGally' plotting

o UPDATE: S3Methods for `EGA.fit` plotting

o FIX: plotting parameters for `bootEGA`

o FIX: redundancy output for adhoc check in `UVA`

o FIX: latent variable with non-space separated entries in `UVA` (`reduce.method = "latent"`)

o UPDATE: `UVA` was added to `methods.section`

o UPDATE: neural network weights in `LCT` (now only tests for factor or small-world network models)

o UPDATE: citations

o UPDATE: added `seed` argument for `bootEGA` to reproduce results

o FIX: bug for Rand index in `itemStability`


Changes in version 0.9.8

o UPDATE: Unidimensional check in `EGA` expands a correlation matrix (rather than generating variables; much more efficient)

o ADD: `color_palette_EGA` New EGA palettes for plotting `ggnet2` EGA network plots (see `?color_palette_EGA`)

o ADD: `UVA` or Unique Variable Analysis operates as a comprehensive handling of variable redundancy in multivariate data (see `?UVA`)

o DEFUNCT: `node.redundant`, `node.redundant.names`, and `node.redundant.combine` will be defunct in next version. Please use `UVA`

o ADD: a new function to compute a parametric Bootstrap Test for the Ergodicity Information Index (see `?boot.ergoInfo`)

o ADD: basic Shiny functionality (`EGA` only)

o ADD: a new function to compute a Monte-Carlo Test for the Ergodicity Information Index (see `?mctest.ergoInfo`)

o ADD: a new function to compute the Ergodicity Information Index (see `?ergoInfo`)

o UPDATE: new plotting scheme using *network* and *GGally* packages

o ADD: a function to produce an automated Methods section for several functions (see `?methods.section`)

o UPDATE: `bootEGA` now implements the updated `EGA` algorithm

o UPDATE: ega.wmt data (unidimensional)

o UPDATE: `itemStability` plot defaults ("GGally" color scheme) and examples (manipulating plot)

o ADD: total correlation (see `?totalCor` and `totalCorMat`)

o ADD: correlation argument (corr) for `EGA`, `bootEGA`, and `UVA`

o FIX: *GGally* color palette when more than 9 dimensions


Changes in version 0.9.7

o UPDATE: `LCT` neural network weights were updated (parametric relu activation function)

o FIX: naming in `EGA`

o FIX: output network matrix in `EGA` when data are input

o UPDATE: citation version

o UPDATE: `node.redundant` now provides a full plot of redundancies detected, descriptive statistics including the critical value, central tendency descriptive statistics, and the distribution the significant values were determined from (thanks to Luis Garrido for the suggestion!)


Changes in version 0.9.6

o UPDATE: `LCT` updated with neural network implementation


Changes in version 0.9.5

o ADD: loadings comparison test function added (see `LCT`)

o FIX: named community memberships in `itemStability` and `dimStability`

o UPDATE: `plot`, `print`, and `summary` methods all moved into single .R files (no effect on user's end)

o UPDATE: `net.scores` global score is improved and computes scores very close to CFA scores

o FIX: additional argument calls for `EGA.estimate` (and `EGA` by extension)

o UPDATE: message from `EGA.estimate` (and `EGA` by extension) reports both 'gamma' and 'lambda.min.ratio' arguments

o FIX: upper quantile output from `bootEGA`

o FIX: minor bugs in `node.redundant`, `itemStability`, and `net.loads`


Changes in version 0.9.4

o MAJOR UPDATE: `dimStability` now computes proportion of exact dimension replications rather than items that replicate within dimension (this latter information can still be found in the output of `itemStability` under $mean.dim.rep)

o FIX: `net.loads` for when dimensions equal one or the number of nodes in the network

o FIX: naming typo with characters in `itemStability`

o FIX: NAs in `dimStability`

o FIX: weights of network in unidimensional structure of `EGA` are the same as multidimensional structure

o UPDATE: Added a new function to simulate dynamic factor models `simDFM`

o UPDATE: added internal functions for `net.loads` (see `utils-net.loads`)

o FIX: ordering of names in `itemStability`

o FIX: handling of NA communities in `net.loads`

o UPDATE: Added output of the average replication of items in each dimension for `itemStability`

o UPDATE: Revised 'Network Scores' vignette

o UPDATE: `net.loads` functionality (cleaned up code)

o UPDATE: S3Methods for `net.loads`

o FIX: `net.scores` negative loadings corrected


Changes in version 0.9.3

o New function and print, summary and plot methods: dynEGA

o New functions: Embed and glla


Changes in version 0.9.2

o UPDATE: add latent variable scores comparison to `net.scores` vignette

o UPDATE: `node.redundant.combine` sets loadings equal to 1 when there are only two variables when the argument type = "latent"; warning also added from type = "sum"

o FIX: `node.redundant` alpha types bug

o updated `itemStability` (bug fixes)

o updated `node.redundant.combine` (bug fixes, latent variable option)

o major bug fix in `net.loads`: corrected loadings greater than 1 when there were many negative values

o added `EGA.estimate` to clean up `EGA` code and allow for future implementations of different network estimation methods and community detection algorithms

o updated `EGA` functionality: message for 'gamma' value used and `EGA.estimate` compatiability

o removed *iterators* dependency

o ordering and name fix in `net.loads`

o auto-adjusts y-axis label size for `itemStability` plot based on number of nodes or length of node names

o `net.loads` adjusted for larger values using absolute values and applying the sign afterwards

o reverse coding update in `net.loads`

o `node.redundant.combine` bug fix for reverse coding latent variables

o added Louvain community detection to all EGA functions in *EGAnet*

o functionality updates to `node.redundant`

o swapped arguments 'type' and 'method' in the `node.redundant` function (fixed examples in other node.redundant functions)

o updated citation


Changes in version 0.9.0

o updated list of dependencies

o added ORCiDs in Description file

o corrected ordering of `net.loads` output

o corrected standard error in `bootEGA`

o citation update

o added function `dimStability` to compute dimensional stability

o added a series of functions for `node.redundant`, which facilitates detecting and combining redundant nodes in networks

o updated the EGA.fit function, so now a correlation matrix can be used as well.


Changes in version 0.8.0

o 'bootEGA' now computes time until bootstrap is finished

o new functions 'cmi', 'pmi' and 'residualEGA' added: 'cmi' computes conditional mutual information, 'pmi' computes partial mutual information and residual EGA computes an EGA network controlling for wording effects

o new dataset 'optimism' added

o documentation and functionality for several functions updated


Changes in version 0.7.0

o fixed 'EGA' bug in 'bootEGA' function; updated 'bootEGA' documentation; added progress messages

o migrated 'net.scores' and 'net.loads' from 'NetworkToolbox' to 'EGAnet' package

o functions 'itemConfirm' and 'itemIdent' have been merged into a single function called, 'itemStability'

o fixed item ordering in 'itemStability' output so dimensions are from least to greatest, the colors match the original community vector input, and updated average standardized network loadings to the 'net.loads' function

o added datasets 'ega.wmt' and 'boot.wmt' for quick user-friendly examples (also removed all '\donttest')

o added package help page

o added package load message

o updated 'itemStability' algorithm (now can accept any number of 'orig.wc') and enforced '0' to '1' bounds on plot
